unit sensor_types;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

type

  // 3 D vector of singles
  V3D_Single = record
    X: single;
    Y: single;
    Z: single;
  end;


  // 3 D vector of 16 bits integers
  V3D_Int16 = record
    X: SmallInt;
    Y: SmallInt;
    Z: SmallInt;
  end;

  // 3 D vector for direct I/O
  V3D_Int16_4IO = record
    case RawInput: boolean of
      True: (bytes: array[0..5] of byte);
      False: (intValues: V3D_Int16);
  end;

  // integer 16 for direct I/O
  Int16_4IO = record
    case RawInput: boolean of
      True: (bytes: array[0..1] of byte);
      False: (intValue: Int16);
  end;

  // integer 32 for direct I/O
  Int32_4IO = record
    case RawInput: boolean of
      True: (bytes: array[0..3] of byte);
      False: (intValue: Int32);
  end;


  // binary display
  function ToS0bxx(AByte : byte): string;


implementation

function ToS0bxx(AByte : byte): string;
var i: integer;
begin
  Result:= '';
  for i:= 0 to 7 do
  begin
    if AByte and 1 = 1
      then Result:= '1' + Result
      else Result:= '0' + Result;
    AByte:= AByte shr 1;
  end;
  Result:= '0b' + Result;
end;


end.

